# Svelte Typed Context

The library re-exports Svelte's getContext and setContext with stricter types.

## Usage

```ts
// in key
import type { InjectionKey } from "./svelte-typed-context"

export const key : InjectionKey<{ foo: number }> = Symbol('Desired type')

// in provider component
import { setContext } from "./svelte-typed-context"
import { key } from "./key"


setContext(key, "bob") // bad -> would error out
setContext(key, { foo: 123 }) // good -> would work

// in consumer component
import { getContext } from "./svelte-typed-context"
import { key } from "./key"

const contextValue = getContext(key) // automatically inferred as { foo: number }
```

## Credits

Inspired by Vue.