import {
    getContext as svelteGetContext,
    setContext as svelteSetContext,
  } from "svelte"
  
  /**
   * Provided as key to getContext and setContext in order to enable strict typing
   */
  export interface InjectionKey<T = unknown> {}
  
  export interface IGetContext {
    <T>(key: InjectionKey<T>): undefined | T
    <T>(key: unknown): T
    (key: unknown): unknown
  }
  
  export interface ISetContext {
    <T>(key: InjectionKey<T>, context: T): void
    <T = unknown>(key: unknown, context: T): void
  }
  
  export const getContext = svelteGetContext as IGetContext
  export const setContext = svelteSetContext as ISetContext
  